diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-phpmailer.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-phpmailer.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-phpmailer.php	2012-06-25 22:54:17.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-phpmailer.php	2013-02-28 12:33:13.000000000 -0600
***************
*** 739,776 ****
      if (empty($this->Sender)) {
        $params = "-oi ";
      } else {
!       $params = sprintf("-oi -f %s", $this->Sender);
      }
      if ($this->Sender != '' and !ini_get('safe_mode')) {
        $old_from = ini_get('sendmail_from');
        ini_set('sendmail_from', $this->Sender);
!       if ($this->SingleTo === true && count($toArr) > 1) {
!         foreach ($toArr as $key => $val) {
!           $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
!           // implement call back function if it exists
!           $isSent = ($rt == 1) ? 1 : 0;
!           $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
!         }
!       } else {
!         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
!         $this->doCallback($isSent, $to, $this->cc, $this->bcc, $this->Subject, $body);
        }
      } else {
!       if ($this->SingleTo === true && count($toArr) > 1) {
!         foreach ($toArr as $key => $val) {
!           $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header);
!           // implement call back function if it exists
!           $isSent = ($rt == 1) ? 1 : 0;
!           $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
!         }
!       } else {
!         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header);
!         // implement call back function if it exists
!         $isSent = ($rt == 1) ? 1 : 0;
!         $this->doCallback($isSent, $to, $this->cc, $this->bcc, $this->Subject, $body);
!       }
      }
      if (isset($old_from)) {
        ini_set('sendmail_from', $old_from);
--- 925,949 ----
      if (empty($this->Sender)) {
        $params = "-oi ";
      } else {
!       $params = sprintf("-oi -f%s", $this->Sender);
      }
      if ($this->Sender != '' and !ini_get('safe_mode')) {
        $old_from = ini_get('sendmail_from');
        ini_set('sendmail_from', $this->Sender);
!     }
!       $rt = false;
!     if ($this->SingleTo === true && count($toArr) > 1) {
!       foreach ($toArr as $val) {
!         $rt = $this->mail_passthru($val, $this->Subject, $body, $header, $params);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
!         $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
        }
      } else {
!       $rt = $this->mail_passthru($to, $this->Subject, $body, $header, $params);
!       // implement call back function if it exists
!       $isSent = ($rt == 1) ? 1 : 0;
!       $this->doCallback($isSent, $to, $this->cc, $this->bcc, $this->Subject, $body);
      }
      if (isset($old_from)) {
        ini_set('sendmail_from', $old_from);
***************
*** 786,791 ****
--- 959,965 ----
     * Returns false if there is a bad MAIL FROM, RCPT, or DATA input.
     * @param string $header The message headers
     * @param string $body The message body
+    * @throws phpmailerException
     * @uses SMTP
     * @access protected
     * @return bool
***************
*** 799,805 ****
      }
      $smtp_from = ($this->Sender == '') ? $this->From : $this->Sender;
      if(!$this->smtp->Mail($smtp_from)) {
!       throw new phpmailerException($this->Lang('from_failed') . $smtp_from, self::STOP_CRITICAL);
      }
  
      // Attempt to send attach all recipients
--- 973,980 ----
      }
      $smtp_from = ($this->Sender == '') ? $this->From : $this->Sender;
      if(!$this->smtp->Mail($smtp_from)) {
!       $this->SetError($this->Lang('from_failed') . $smtp_from . " : " . implode(",",$this->smtp->getError())) ;
!       throw new phpmailerException($this->ErrorInfo, self::STOP_CRITICAL);
      }
  
      // Attempt to send attach all recipients
***************
*** 850,855 ****
--- 1025,1033 ----
      }
      if($this->SMTPKeepAlive == true) {
        $this->smtp->Reset();
+     } else {
+         $this->smtp->Quit();
+         $this->smtp->Close();
      }
      return true;
    }
***************
*** 859,871 ****
     * Returns false if the operation failed.
     * @uses SMTP
     * @access public
     * @return bool
     */
    public function SmtpConnect() {
      if(is_null($this->smtp)) {
!       $this->smtp = new SMTP();
      }
  
      $this->smtp->do_debug = $this->SMTPDebug;
      $hosts = explode(';', $this->Host);
      $index = 0;
--- 1037,1051 ----
     * Returns false if the operation failed.
     * @uses SMTP
     * @access public
+    * @throws phpmailerException
     * @return bool
     */
    public function SmtpConnect() {
      if(is_null($this->smtp)) {
!       $this->smtp = new SMTP;
      }
  
+     $this->smtp->Timeout = $this->Timeout;
      $this->smtp->do_debug = $this->SMTPDebug;
      $hosts = explode(';', $this->Host);
      $index = 0;
***************
*** 893,899 ****
  
            if ($tls) {
              if (!$this->smtp->StartTLS()) {
!               throw new phpmailerException($this->Lang('tls'));
              }
  
              //We must resend HELO after tls negotiation
--- 1073,1079 ----
  
            if ($tls) {
              if (!$this->smtp->StartTLS()) {
!               throw new phpmailerException($this->Lang('connect_host'));
              }
  
              //We must resend HELO after tls negotiation
***************
*** 902,920 ****
  
            $connection = true;
            if ($this->SMTPAuth) {
!             if (!$this->smtp->Authenticate($this->Username, $this->Password)) {
                throw new phpmailerException($this->Lang('authenticate'));
              }
            }
          }
          $index++;
!         if (!$connection) {
!           throw new phpmailerException($this->Lang('connect_host'));
!         }
        }
      } catch (phpmailerException $e) {
        $this->smtp->Reset();
! 	  if ($this->exceptions) {
          throw $e;
        }
      }
--- 1082,1101 ----
  
            $connection = true;
            if ($this->SMTPAuth) {
!             if (!$this->smtp->Authenticate($this->Username, $this->Password, $this->AuthType,
!                                            $this->Realm, $this->Workstation)) {
                throw new phpmailerException($this->Lang('authenticate'));
              }
            }
          }
          $index++;
!       if (!$connection) {
!         throw new phpmailerException($this->Lang('connect_host'));
!       }
        }
      } catch (phpmailerException $e) {
        $this->smtp->Reset();
!       if ($this->exceptions) {
          throw $e;
        }
      }
***************
*** 926,932 ****
     * @return void
     */
    public function SmtpClose() {
!     if(!is_null($this->smtp)) {
        if($this->smtp->Connected()) {
          $this->smtp->Quit();
          $this->smtp->Close();
--- 1107,1113 ----
     * @return void
     */
    public function SmtpClose() {
!     if ($this->smtp !== null) {
        if($this->smtp->Connected()) {
          $this->smtp->Quit();
          $this->smtp->Close();
***************
*** 939,966 ****
    * Returns false if it cannot load the language file.  The default language is English.
    * @param string $langcode ISO 639-1 2-character language code (e.g. Portuguese: "br")
    * @param string $lang_path Path to the language file directory
    * @access public
    */
    function SetLanguage($langcode = 'en', $lang_path = 'language/') {
      //Define full set of translatable strings
      $PHPMAILER_LANG = array(
!       'provide_address' => 'You must provide at least one recipient email address.',
        'mailer_not_supported' => ' mailer is not supported.',
!       'execute' => 'Could not execute: ',
!       'instantiate' => 'Could not instantiate mail function.',
!       'authenticate' => 'SMTP Error: Could not authenticate.',
!       'from_failed' => 'The following From address failed: ',
!       'recipients_failed' => 'SMTP Error: The following recipients failed: ',
!       'data_not_accepted' => 'SMTP Error: Data not accepted.',
!       'connect_host' => 'SMTP Error: Could not connect to SMTP host.',
!       'file_access' => 'Could not access file: ',
!       'file_open' => 'File Error: Could not open file: ',
!       'encoding' => 'Unknown encoding: ',
!       'signing' => 'Signing Error: ',
!       'smtp_error' => 'SMTP server error: ',
!       'empty_message' => 'Message body empty',
!       'invalid_address' => 'Invalid address',
!       'variable_set' => 'Cannot set or reset variable: '
      );
      //Overwrite language-specific strings. This way we'll never have missing translations - no more "language string failed to load"!
      $l = true;
--- 1120,1149 ----
    * Returns false if it cannot load the language file.  The default language is English.
    * @param string $langcode ISO 639-1 2-character language code (e.g. Portuguese: "br")
    * @param string $lang_path Path to the language file directory
+    * @return bool
    * @access public
    */
    function SetLanguage($langcode = 'en', $lang_path = 'language/') {
      //Define full set of translatable strings
      $PHPMAILER_LANG = array(
!       'authenticate'         => 'SMTP Error: Could not authenticate.',
!       'connect_host'         => 'SMTP Error: Could not connect to SMTP host.',
!       'data_not_accepted'    => 'SMTP Error: Data not accepted.',
!       'empty_message'        => 'Message body empty',
!       'encoding'             => 'Unknown encoding: ',
!       'execute'              => 'Could not execute: ',
!       'file_access'          => 'Could not access file: ',
!       'file_open'            => 'File Error: Could not open file: ',
!       'from_failed'          => 'The following From address failed: ',
!       'instantiate'          => 'Could not instantiate mail function.',
!       'invalid_address'      => 'Invalid address',
        'mailer_not_supported' => ' mailer is not supported.',
!       'provide_address'      => 'You must provide at least one recipient email address.',
!       'recipients_failed'    => 'SMTP Error: The following recipients failed: ',
!       'signing'              => 'Signing Error: ',
!       'smtp_connect_failed'  => 'SMTP Connect() failed.',
!       'smtp_error'           => 'SMTP server error: ',
!       'variable_set'         => 'Cannot set or reset variable: '
      );
      //Overwrite language-specific strings. This way we'll never have missing translations - no more "language string failed to load"!
      $l = true;
***************
*** 986,991 ****
--- 1169,1176 ----
    /**
     * Creates recipient headers.
     * @access public
+    * @param string $type
+    * @param array $addr
     * @return string
     */
    public function AddrAppend($type, $addr) {
***************
*** 1003,1008 ****
--- 1188,1194 ----
    /**
     * Formats an address correctly.
     * @access public
+    * @param string $addr
     * @return string
     */
    public function AddrFormat($addr) {
***************
*** 1028,1040 ****
      // If utf-8 encoding is used, we will need to make sure we don't
      // split multibyte characters when we wrap
      $is_utf8 = (strtolower($this->CharSet) == "utf-8");
  
      $message = $this->FixEOL($message);
!     if (substr($message, -1) == $this->LE) {
!       $message = substr($message, 0, -1);
      }
  
!     $line = explode($this->LE, $message);
      $message = '';
      for ($i = 0 ;$i < count($line); $i++) {
        $line_part = explode(' ', $line[$i]);
--- 1214,1228 ----
      // If utf-8 encoding is used, we will need to make sure we don't
      // split multibyte characters when we wrap
      $is_utf8 = (strtolower($this->CharSet) == "utf-8");
+     $lelen = strlen($this->LE);
+     $crlflen = strlen(self::CRLF);
  
      $message = $this->FixEOL($message);
!     if (substr($message, -$lelen) == $this->LE) {
!       $message = substr($message, 0, -$lelen);
      }
  
!     $line = explode($this->LE, $message);   // Magic. We know FixEOL uses $LE
      $message = '';
      for ($i = 0 ;$i < count($line); $i++) {
        $line_part = explode(' ', $line[$i]);
***************
*** 1042,1048 ****
        for ($e = 0; $e<count($line_part); $e++) {
          $word = $line_part[$e];
          if ($qp_mode and (strlen($word) > $length)) {
!           $space_left = $length - strlen($buf) - 1;
            if ($e != 0) {
              if ($space_left > 20) {
                $len = $space_left;
--- 1230,1236 ----
        for ($e = 0; $e<count($line_part); $e++) {
          $word = $line_part[$e];
          if ($qp_mode and (strlen($word) > $length)) {
!           $space_left = $length - strlen($buf) - $crlflen;
            if ($e != 0) {
              if ($space_left > 20) {
                $len = $space_left;
***************
*** 1056,1062 ****
                $part = substr($word, 0, $len);
                $word = substr($word, $len);
                $buf .= ' ' . $part;
!               $message .= $buf . sprintf("=%s", $this->LE);
              } else {
                $message .= $buf . $soft_break;
              }
--- 1244,1250 ----
                $part = substr($word, 0, $len);
                $word = substr($word, $len);
                $buf .= ' ' . $part;
!               $message .= $buf . sprintf("=%s", self::CRLF);
              } else {
                $message .= $buf . $soft_break;
              }
***************
*** 1075,1081 ****
              $word = substr($word, $len);
  
              if (strlen($word) > 0) {
!               $message .= $part . sprintf("=%s", $this->LE);
              } else {
                $buf = $part;
              }
--- 1263,1269 ----
              $word = substr($word, $len);
  
              if (strlen($word) > 0) {
!               $message .= $part . sprintf("=%s", self::CRLF);
              } else {
                $buf = $part;
              }
***************
*** 1090,1096 ****
            }
          }
        }
!       $message .= $buf . $this->LE;
      }
  
      return $message;
--- 1278,1284 ----
            }
          }
        }
!       $message .= $buf . self::CRLF;
      }
  
      return $message;
***************
*** 1175,1182 ****
      $this->boundary[2] = 'b2_' . $uniq_id;
      $this->boundary[3] = 'b3_' . $uniq_id;
  
!     $result .= $this->HeaderLine('Date', self::RFCDate());
!     if($this->Sender == '') {
        $result .= $this->HeaderLine('Return-Path', trim($this->From));
      } else {
        $result .= $this->HeaderLine('Return-Path', trim($this->Sender));
--- 1363,1377 ----
      $this->boundary[2] = 'b2_' . $uniq_id;
      $this->boundary[3] = 'b3_' . $uniq_id;
  
!     if ($this->MessageDate == '') {
!       $result .= $this->HeaderLine('Date', self::RFCDate());
!     } else {
!       $result .= $this->HeaderLine('Date', $this->MessageDate);
!     }
! 
!     if ($this->ReturnPath) {
!       $result .= $this->HeaderLine('Return-Path', trim($this->ReturnPath));
!     } elseif ($this->Sender == '') {
        $result .= $this->HeaderLine('Return-Path', trim($this->From));
      } else {
        $result .= $this->HeaderLine('Return-Path', trim($this->Sender));
***************
*** 1195,1201 ****
            $result .= $this->HeaderLine('To', 'undisclosed-recipients:;');
          }
        }
! 	}
  
      $from = array();
      $from[0][0] = trim($this->From);
--- 1390,1396 ----
            $result .= $this->HeaderLine('To', 'undisclosed-recipients:;');
          }
        }
!     }
  
      $from = array();
      $from[0][0] = trim($this->From);
***************
*** 1227,1236 ****
        $result .= sprintf("Message-ID: <%s@%s>%s", $uniq_id, $this->ServerHostname(), $this->LE);
      }
      $result .= $this->HeaderLine('X-Priority', $this->Priority);
!     if($this->XMailer) {
!       $result .= $this->HeaderLine('X-Mailer', $this->XMailer);
      } else {
!       $result .= $this->HeaderLine('X-Mailer', 'PHPMailer '.$this->Version.' (http://code.google.com/a/apache-extras.org/p/phpmailer/)');
      }
  
      if($this->ConfirmReadingTo != '') {
--- 1422,1434 ----
        $result .= sprintf("Message-ID: <%s@%s>%s", $uniq_id, $this->ServerHostname(), $this->LE);
      }
      $result .= $this->HeaderLine('X-Priority', $this->Priority);
!     if ($this->XMailer == '') {
!         $result .= $this->HeaderLine('X-Mailer', 'PHPMailer '.$this->Version.' (http://code.google.com/a/apache-extras.org/p/phpmailer/)');
      } else {
!       $myXmailer = trim($this->XMailer);
!       if ($myXmailer) {
!         $result .= $this->HeaderLine('X-Mailer', $myXmailer);
!       }
      }
  
      if($this->ConfirmReadingTo != '') {
***************
*** 1257,1266 ****
    public function GetMailMIME() {
      $result = '';
      switch($this->message_type) {
-       case 'plain':
-         $result .= $this->HeaderLine('Content-Transfer-Encoding', $this->Encoding);
-         $result .= $this->TextLine('Content-Type: '.$this->ContentType.'; charset="'.$this->CharSet.'"');
-         break;
        case 'inline':
          $result .= $this->HeaderLine('Content-Type', 'multipart/related;');
          $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
--- 1455,1460 ----
***************
*** 1277,1286 ****
          $result .= $this->HeaderLine('Content-Type', 'multipart/alternative;');
          $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
          break;
      }
  
      if($this->Mailer != 'mail') {
!       $result .= $this->LE.$this->LE;
      }
  
      return $result;
--- 1471,1485 ----
          $result .= $this->HeaderLine('Content-Type', 'multipart/alternative;');
          $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
          break;
+       default:
+         // Catches case 'plain': and case '':
+         $result .= $this->HeaderLine('Content-Transfer-Encoding', $this->Encoding);
+         $result .= $this->TextLine('Content-Type: '.$this->ContentType.'; charset='.$this->CharSet);
+         break;
      }
  
      if($this->Mailer != 'mail') {
!       $result .= $this->LE;
      }
  
      return $result;
***************
*** 1292,1319 ****
     * @return string
     */
    public function GetSentMIMEMessage() {
!     return $this->SentMIMEMessage;
    }
  
  
    /**
     * Assembles the message body.  Returns an empty string on failure.
     * @access public
     * @return string The assembled message body
     */
    public function CreateBody() {
      $body = '';
  
      if ($this->sign_key_file) {
!       $body .= $this->GetMailMIME();
      }
  
      $this->SetWordWrap();
  
      switch($this->message_type) {
-       case 'plain':
-         $body .= $this->EncodeString($this->Body, $this->Encoding);
-         break;
        case 'inline':
          $body .= $this->GetBoundary($this->boundary[1], '', '', '');
          $body .= $this->EncodeString($this->Body, $this->Encoding);
--- 1491,1516 ----
     * @return string
     */
    public function GetSentMIMEMessage() {
!     return $this->MIMEHeader . $this->mailHeader . self::CRLF . $this->MIMEBody;
    }
  
  
    /**
     * Assembles the message body.  Returns an empty string on failure.
     * @access public
+    * @throws phpmailerException
     * @return string The assembled message body
     */
    public function CreateBody() {
      $body = '';
  
      if ($this->sign_key_file) {
!       $body .= $this->GetMailMIME().$this->LE;
      }
  
      $this->SetWordWrap();
  
      switch($this->message_type) {
        case 'inline':
          $body .= $this->GetBoundary($this->boundary[1], '', '', '');
          $body .= $this->EncodeString($this->Body, $this->Encoding);
***************
*** 1398,1403 ****
--- 1595,1604 ----
          $body .= $this->LE;
          $body .= $this->AttachAll("attachment", $this->boundary[1]);
          break;
+       default:
+         // catch case 'plain' and case ''
+         $body .= $this->EncodeString($this->Body, $this->Encoding);
+         break;
      }
  
      if ($this->IsError()) {
***************
*** 1430,1435 ****
--- 1631,1640 ----
    /**
     * Returns the start of a message boundary.
     * @access protected
+    * @param string $boundary
+    * @param string $charSet
+    * @param string $contentType
+    * @param string $encoding
     * @return string
     */
    protected function GetBoundary($boundary, $charSet, $contentType, $encoding) {
***************
*** 1444,1450 ****
        $encoding = $this->Encoding;
      }
      $result .= $this->TextLine('--' . $boundary);
!     $result .= sprintf("Content-Type: %s; charset=\"%s\"", $contentType, $charSet);
      $result .= $this->LE;
      $result .= $this->HeaderLine('Content-Transfer-Encoding', $encoding);
      $result .= $this->LE;
--- 1649,1655 ----
        $encoding = $this->Encoding;
      }
      $result .= $this->TextLine('--' . $boundary);
!     $result .= sprintf("Content-Type: %s; charset=%s", $contentType, $charSet);
      $result .= $this->LE;
      $result .= $this->HeaderLine('Content-Transfer-Encoding', $encoding);
      $result .= $this->LE;
***************
*** 1455,1460 ****
--- 1660,1666 ----
    /**
     * Returns the end of a message boundary.
     * @access protected
+    * @param string $boundary
     * @return string
     */
    protected function EndBoundary($boundary) {
***************
*** 1478,1483 ****
--- 1684,1691 ----
    /**
     *  Returns a formatted header line.
     * @access public
+    * @param string $name
+    * @param string $value
     * @return string
     */
    public function HeaderLine($name, $value) {
***************
*** 1487,1492 ****
--- 1695,1701 ----
    /**
     * Returns a formatted mail line.
     * @access public
+    * @param string $value
     * @return string
     */
    public function TextLine($value) {
***************
*** 1505,1510 ****
--- 1714,1720 ----
     * @param string $name Overrides the attachment name.
     * @param string $encoding File encoding (see $Encoding).
     * @param string $type File extension (MIME) type.
+    * @throws phpmailerException
     * @return bool
     */
    public function AddAttachment($path, $name = '', $encoding = 'base64', $type = 'application/octet-stream') {
***************
*** 1533,1540 ****
        if ($this->exceptions) {
          throw $e;
        }
! 	  if ($this->SMTPDebug) {
!         echo $e->getMessage()."\n";
        }
        if ( $e->getCode() == self::STOP_CRITICAL ) {
          return false;
--- 1743,1750 ----
        if ($this->exceptions) {
          throw $e;
        }
!       if ($this->SMTPDebug) {
!         $this->edebug($e->getMessage()."\n");
        }
        if ( $e->getCode() == self::STOP_CRITICAL ) {
          return false;
***************
*** 1555,1560 ****
--- 1765,1772 ----
     * Attaches all fs, string, and binary attachments to the message.
     * Returns an empty string on failure.
     * @access protected
+    * @param string $disposition_type
+    * @param string $boundary
     * @return string
     */
    protected function AttachAll($disposition_type, $boundary) {
***************
*** 1568,1573 ****
--- 1780,1787 ----
        // CHECK IF IT IS A VALID DISPOSITION_FILTER
        if($attachment[6] == $disposition_type) {
          // Check for string attachment
+         $string = '';
+         $path = '';
          $bString = $attachment[5];
          if ($bString) {
            $string = $attachment[0];
***************
*** 1624,1629 ****
--- 1838,1844 ----
     * Returns an empty string on failure.
     * @param string $path The full path to the file
     * @param string $encoding The encoding to use; one of 'base64', '7bit', '8bit', 'binary', 'quoted-printable'
+    * @throws phpmailerException
     * @see EncodeFile()
     * @access protected
     * @return string
***************
*** 1633,1660 ****
        if (!is_readable($path)) {
          throw new phpmailerException($this->Lang('file_open') . $path, self::STOP_CONTINUE);
        }
!       if (function_exists('get_magic_quotes')) {
!         function get_magic_quotes() {
!           return false;
!         }
!       }
! 	  $magic_quotes = get_magic_quotes_runtime();
! 	  if ($magic_quotes) {
          if (version_compare(PHP_VERSION, '5.3.0', '<')) {
            set_magic_quotes_runtime(0);
          } else {
! 		  ini_set('magic_quotes_runtime', 0);
! 		}
! 	  }
        $file_buffer  = file_get_contents($path);
        $file_buffer  = $this->EncodeString($file_buffer, $encoding);
! 	  if ($magic_quotes) {
          if (version_compare(PHP_VERSION, '5.3.0', '<')) {
            set_magic_quotes_runtime($magic_quotes);
          } else {
! 		  ini_set('magic_quotes_runtime', $magic_quotes);
! 	    }
! 	  }
        return $file_buffer;
      } catch (Exception $e) {
        $this->SetError($e->getMessage());
--- 1848,1875 ----
        if (!is_readable($path)) {
          throw new phpmailerException($this->Lang('file_open') . $path, self::STOP_CONTINUE);
        }
!       //  if (!function_exists('get_magic_quotes')) {
!       //    function get_magic_quotes() {
!       //      return false;
!       //    }
!       //  }
!       $magic_quotes = get_magic_quotes_runtime();
!       if ($magic_quotes) {
          if (version_compare(PHP_VERSION, '5.3.0', '<')) {
            set_magic_quotes_runtime(0);
          } else {
!           ini_set('magic_quotes_runtime', 0); 
!         }
!       }
        $file_buffer  = file_get_contents($path);
        $file_buffer  = $this->EncodeString($file_buffer, $encoding);
!       if ($magic_quotes) {
          if (version_compare(PHP_VERSION, '5.3.0', '<')) {
            set_magic_quotes_runtime($magic_quotes);
          } else {
!           ini_set('magic_quotes_runtime', $magic_quotes); 
!         }
!       }
        return $file_buffer;
      } catch (Exception $e) {
        $this->SetError($e->getMessage());
***************
*** 1699,1704 ****
--- 1914,1921 ----
    /**
     * Encode a header string to best (shortest) of Q, B, quoted or none.
     * @access public
+    * @param string $str
+    * @param string $position
     * @return string
     */
    public function EncodeHeader($str, $position = 'text') {
***************
*** 1737,1743 ****
        if (function_exists('mb_strlen') && $this->HasMultiBytes($str)) {
          // Use a custom function which correctly encodes and wraps long
          // multibyte strings without breaking lines within a character
!         $encoded = $this->Base64EncodeWrapMB($str);
        } else {
          $encoded = base64_encode($str);
          $maxlen -= $maxlen % 4;
--- 1954,1960 ----
        if (function_exists('mb_strlen') && $this->HasMultiBytes($str)) {
          // Use a custom function which correctly encodes and wraps long
          // multibyte strings without breaking lines within a character
!         $encoded = $this->Base64EncodeWrapMB($str, "\n");
        } else {
          $encoded = base64_encode($str);
          $maxlen -= $maxlen % 4;
***************
*** 1747,1753 ****
        $encoding = 'Q';
        $encoded = $this->EncodeQ($str, $position);
        $encoded = $this->WrapText($encoded, $maxlen, true);
!       $encoded = str_replace('='.$this->LE, "\n", trim($encoded));
      }
  
      $encoded = preg_replace('/^(.*)$/m', " =?".$this->CharSet."?$encoding?\\1?=", $encoded);
--- 1964,1970 ----
        $encoding = 'Q';
        $encoded = $this->EncodeQ($str, $position);
        $encoded = $this->WrapText($encoded, $maxlen, true);
!       $encoded = str_replace('='.self::CRLF, "\n", trim($encoded));
      }
  
      $encoded = preg_replace('/^(.*)$/m', " =?".$this->CharSet."?$encoding?\\1?=", $encoded);
***************
*** 1776,1787 ****
     * Adapted from a function by paravoid at http://uk.php.net/manual/en/function.mb-encode-mimeheader.php
     * @access public
     * @param string $str multi-byte text to wrap encode
     * @return string
     */
!   public function Base64EncodeWrapMB($str) {
      $start = "=?".$this->CharSet."?B?";
      $end = "?=";
      $encoded = "";
  
      $mb_length = mb_strlen($str, $this->CharSet);
      // Each line must have length <= 75, including $start and $end
--- 1993,2008 ----
     * Adapted from a function by paravoid at http://uk.php.net/manual/en/function.mb-encode-mimeheader.php
     * @access public
     * @param string $str multi-byte text to wrap encode
+    * @param string $lf string to use as linefeed/end-of-line
     * @return string
     */
!   public function Base64EncodeWrapMB($str, $lf=null) {
      $start = "=?".$this->CharSet."?B?";
      $end = "?=";
      $encoded = "";
+     if ($lf === null) {
+       $lf = $this->LE;
+     }
  
      $mb_length = mb_strlen($str, $this->CharSet);
      // Each line must have length <= 75, including $start and $end
***************
*** 1802,1812 ****
        }
        while (strlen($chunk) > $length);
  
!       $encoded .= $chunk . $this->LE;
      }
  
      // Chomp the last linefeed
!     $encoded = substr($encoded, 0, -strlen($this->LE));
      return $encoded;
    }
  
--- 2023,2033 ----
        }
        while (strlen($chunk) > $length);
  
!       $encoded .= $chunk . $lf;
      }
  
      // Chomp the last linefeed
!     $encoded = substr($encoded, 0, -strlen($lf));
      return $encoded;
    }
  
***************
*** 1814,1821 ****
    * Encode string to quoted-printable.
    * Only uses standard PHP, slow, but will always work
    * @access public
!   * @param string $string the text to encode
    * @param integer $line_max Number of chars allowed on a line before wrapping
    * @return string
    */
    public function EncodeQPphp( $input = '', $line_max = 76, $space_conv = false) {
--- 2035,2044 ----
    * Encode string to quoted-printable.
    * Only uses standard PHP, slow, but will always work
    * @access public
!    * @param string $input
    * @param integer $line_max Number of chars allowed on a line before wrapping
+    * @param bool $space_conv
+    * @internal param string $string the text to encode
    * @return string
    */
    public function EncodeQPphp( $input = '', $line_max = 76, $space_conv = false) {
***************
*** 1840,1847 ****
              $c = '=20';
            }
          } elseif ( ($dec == 61) || ($dec < 32 ) || ($dec > 126) ) { // always encode "\t", which is *not* required
!           $h2 = floor($dec/16);
!           $h1 = floor($dec%16);
            $c = $escape.$hex[$h2].$hex[$h1];
          }
          if ( (strlen($newline) + strlen($c)) >= $line_max ) { // CRLF is not counted
--- 2063,2070 ----
              $c = '=20';
            }
          } elseif ( ($dec == 61) || ($dec < 32 ) || ($dec > 126) ) { // always encode "\t", which is *not* required
!           $h2 = (integer)floor($dec/16);
!           $h1 = (integer)floor($dec%16);
            $c = $escape.$hex[$h2].$hex[$h1];
          }
          if ( (strlen($newline) + strlen($c)) >= $line_max ) { // CRLF is not counted
